
import ij.ImagePlus;
import ij.gui.GenericDialog;
import ij.plugin.filter.PlugInFilter;
import ij.process.ImageProcessor;

public class SusanEdges_
    implements PlugInFilter
{ 

    public int setup(String arg0, ImagePlus arg1)
    {
        img = arg1;
        return 65;
    }
 
    public void run(ImageProcessor ip)
    {
        ipref = ip;
        int width = img.getWidth();
        int height = img.getHeight();
        int depth = img.getStackSize();
        boolean no_principle = false;
        boolean use3x3 = false;
        boolean thinpp = true;
        int bt = 40;
        int max_edges=2000;
        boolean drawBorder=true;
        
        
        GenericDialog gd = new GenericDialog("Calculate fractal dimension");
       
        gd.addCheckbox("Mark edges", no_principle);
        gd.addNumericField("Brightness threshold", bt, 0);
        gd.addCheckbox("Use simple 3x3", use3x3);
        gd.addNumericField("Max number of edges ", max_edges, 0);
         
        gd.addMessage("Options for edge markings:");
        gd.addCheckbox("Thin post proc. ", thinpp);
        gd.addCheckbox("Draw white border around edges",drawBorder);
        drawBorder = gd.getNextBoolean();
        
        gd.showDialog();
        if(gd.wasCanceled()) 
            return;
        no_principle = gd.getNextBoolean();
        use3x3 =gd.getNextBoolean();
        thinpp = gd.getNextBoolean();
        
        drawBorder=gd.getNextBoolean();
        
        bt = (int)gd.getNextNumber();
        max_edges = (int)gd.getNextNumber();
        
         byte imageData[] = new byte[width * height * depth]; 
        int sliceSize = width * height; 
      
         
        for(int z = 0; z < depth; z++) 
        { 
            byte src[] = (byte[])img.getStack().getPixels(z + 1);
            System.arraycopy(src, 0, imageData, sliceSize * z, sliceSize);
        
        }
       if(drawBorder)SusanFilter3D.susan_edges(use3x3,imageData,!no_principle,thinpp,max_edges,bt,width,height,0);
       else SusanFilter3D.susan_edges(use3x3,imageData,!no_principle,thinpp,max_edges,bt,width,height,1);
       
        for(int z = 0; z < depth; z++)
        {
            byte dst[] = (byte[])img.getStack().getPixels(z + 1);
            System.arraycopy(imageData, sliceSize * z, dst, 0, sliceSize);
        }
    }
   

    static ImagePlus img;
    static ImageProcessor ipref;

}
