
import ij.ImagePlus;
import ij.gui.GenericDialog;
import ij.plugin.filter.PlugInFilter;
import ij.process.ImageProcessor;

public class SusanSmoothing_
implements PlugInFilter
{ 
	
	public int setup(String arg0, ImagePlus arg1)
	{
		img = arg1;
		return 65;
	}
	
	public void run(ImageProcessor ip)
	{
		ipref = ip;
		int width = img.getWidth();
		int height = img.getHeight();
		int depth = img.getStackSize();
		boolean useMedian = true;
		boolean use3x3 = false;
		int bt = 40; 
		float sigma = 2F;
		boolean use_3d=true;
		GenericDialog gd = new GenericDialog("Calculate fractal dimension");
		gd.addCheckbox("Apply median", true);
		gd.addCheckbox("Fast 3x3 mode", false);
		gd.addNumericField("Brightness threshold", bt, 0);
		gd.addNumericField("Spacial size ( sigma ) ", sigma, 1);
		
		gd.addCheckbox("Use 3D ", use_3d);
		
		
		gd.showDialog();
		if(gd.wasCanceled())
			return;
		useMedian = gd.getNextBoolean();
		use3x3 = gd.getNextBoolean();
		bt = (int)gd.getNextNumber();
		sigma = (float)gd.getNextNumber();
		use_3d = gd.getNextBoolean();
		byte imageData[] = new byte[width * height * depth]; 
		int sliceSize = width * height; 
		
		
		for(int z = 0; z < depth; z++) 
		{ 
			byte src[] = (byte[])img.getStack().getPixels(z + 1);
			System.arraycopy(src, 0, imageData, sliceSize * z, sliceSize);
			
		}
		
		if(use_3d)SusanFilter3D.susan_smoothing3d(use3x3, imageData, sigma, bt, width, height, depth, useMedian);
		else {
			SusanFilter3D.susan_smoothing2d(use3x3, imageData, sigma, bt, width, height, depth, useMedian);
			
		}
		for(int z = 0; z < depth; z++)
		{
			byte dst[] = (byte[])img.getStack().getPixels(z + 1);
			System.arraycopy(imageData, sliceSize * z, dst, 0, sliceSize);
		}
	}
	
	static ImagePlus img;
	static ImageProcessor ipref;
	
}
